/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this source file. It is generated from DrBase repository.
 *
 *  Built on: 2023-07-26 09:04:22Z
 *****************************************************************************/

#include "rshmc804x.h"

/*****************************************************************************
 *- Repeated Capabilities ---------------------------------------------------*
 *****************************************************************************/

ViInt32 rshmc804x_RsCoreRepCapTableCount = 1;

RsCoreRepCap rshmc804x_RsCoreRepCapTable[1] =
  { /*
    {
      repCapName  ... Repeated capability name, e.g. "Channel"
      identifiers ... Repeated capability identifiers (comma separated values), e.g. "Ch1,Ch2,Ch3"
      cmdValues   ... Command values (comma separated values), e.g. "1,2,3"
    } */
    {
      "Channel",
      "CH1,CH2,CH3,CH4",
      "1,2,3,4"
    }
  };

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/

static RsCoreRangeTableDiscreteEntry rshmc804x_rngMeasurementTypeEntries[4] =
  {
    { RSHMC804X_VAL_MEASURE_VOLTAGE, "VOLT" },
    { RSHMC804X_VAL_MEASURE_CURRENT, "CURR" },
    { RSHMC804X_VAL_MEASURE_POWER, "POW" },
    { RSHMC804X_VAL_MEASURE_ENERGY, "ENER" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngMeasurementType = { 4, rshmc804x_rngMeasurementTypeEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngTriggerSlopeEntries[2] =
  {
    { RSHMC804X_VAL_TRIGGER_SLOPE_NEGATIVE, "NEG" },
    { RSHMC804X_VAL_TRIGGER_SLOPE_POSITIVE, "POS" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngTriggerSlope = { 2, rshmc804x_rngTriggerSlopeEntries };

RsCoreRangeTableRanged rshmc804x_rngChannelCount = { 1, 3, "" };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngOvpModeEntries[2] =
  {
    { RSHMC804X_VAL_OVP_MODE_MEASURED, "MEAS" },
    { RSHMC804X_VAL_OVP_MODE_PROTECTED, "PROT" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngOvpMode = { 2, rshmc804x_rngOvpModeEntries };

RsCoreRangeTableRanged rshmc804x_rngRampDuration = { 0.0, 10.0, "s" };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngAnalogInputEntries[2] =
  {
    { RSHMC804X_VAL_AINPUT_VOLTAGE, "VOLT" },
    { RSHMC804X_VAL_AINPUT_CURRENT, "CURR" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngAnalogInput = { 2, rshmc804x_rngAnalogInputEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngAnalogInputModeEntries[2] =
  {
    { RSHMC804X_VAL_AINPUT_MODE_LINEAR, "LIN" },
    { RSHMC804X_VAL_AINPUT_MODE_STEP, "STEP" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngAnalogInputMode = { 2, rshmc804x_rngAnalogInputModeEntries };

RsCoreRangeTableRanged rshmc804x_rngFuseDelay = { 10.0e-3, 10.0, "s" };

RsCoreRangeTableRanged rshmc804x_rngFuseLink = { 1, 3, "" };

RsCoreRangeTableRanged rshmc804x_rngArbitraryRepetitions = { 0, 65535, "" };

RsCoreRangeTableRanged rshmc804x_rngArbitraryEndpoint = { 1, 512, "" };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngLoggingFormatEntries[2] =
  {
    { RSHMC804X_VAL_LOGGING_FORMAT_CSV, "CSV" },
    { RSHMC804X_VAL_LOGGING_FORMAT_TXT, "TXT" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngLoggingFormat = { 2, rshmc804x_rngLoggingFormatEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngLoggingModeEntries[3] =
  {
    { RSHMC804X_VAL_LOGGING_MODE_UNLIMITED, "UNL" },
    { RSHMC804X_VAL_LOGGING_MODE_COUNT, "COUN" },
    { RSHMC804X_VAL_LOGGING_MODE_TIME, "TIME" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngLoggingMode = { 3, rshmc804x_rngLoggingModeEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngDeviceEntries[3] =
  {
    { RSHMC804X_VAL_DEVICE_INT, "INT" },
    { RSHMC804X_VAL_DEVICE_EXT, "EXT" },
    { RSHMC804X_VAL_DEVICE_DEF, "DEF" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngDevice = { 3, rshmc804x_rngDeviceEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngRegisterGroupEntries[4] =
  {
    { RSHMC804X_VAL_REGISTER_GROUP_OPER, "OPER" },
    { RSHMC804X_VAL_REGISTER_GROUP_QUES, "QUES" },
    { RSHMC804X_VAL_REGISTER_GROUP_QUES_INST, "QUES:INST" },
    { RSHMC804X_VAL_REGISTER_GROUP_QUES_INST_ISUM, "QUEST:INST:ISUM" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngRegisterGroup = { 4, rshmc804x_rngRegisterGroupEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngRegisterTypeEntries[3] =
  {
    { RSHMC804X_VAL_REGISTER_TYPE_COND, "COND" },
    { RSHMC804X_VAL_REGISTER_TYPE_EVEN, "EVEN" },
    { RSHMC804X_VAL_REGISTER_TYPE_ENAB, "ENAB" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngRegisterType = { 3, rshmc804x_rngRegisterTypeEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngImageFormatEntries[2] =
  {
    { RSHMC804X_VAL_IMAGE_FORMAT_BMP, "BMP" },
    { RSHMC804X_VAL_IMAGE_FORMAT_PNG, "PNG" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngImageFormat = { 2, rshmc804x_rngImageFormatEntries };

static RsCoreRangeTableDiscreteEntry rshmc804x_rngTriggerModeEntries[2] =
  {
    { RSHMC804X_VAL_TRIGGER_MODE_SINGLE, "SING" },
    { RSHMC804X_VAL_TRIGGER_MODE_RUN, "RUN" }
  };
RsCoreRangeTableDiscrete rshmc804x_rngTriggerMode = { 2, rshmc804x_rngTriggerModeEntries };

static RsCoreRangeTableDiscreteEntry RsHmc804x_rngChannelFusionEntries[3] =
  {
    { RSHMC804X_VAL_CHANNEL_FUSION_OFF, "OFF" },
    { RSHMC804X_VAL_CHANNEL_FUSION_SERIES, "SER" },
    { RSHMC804X_VAL_CHANNEL_FUSION_PARALLEL, "PAR" }
  };
RsCoreRangeTableDiscrete RsHmc804x_rngChannelFusion = { 3, RsHmc804x_rngChannelFusionEntries };

static RsCoreRangeTableDiscreteEntry RsHmc804x_rngOutputModeEntries[3] =
  {
    { RSHMC804X_VAL_OUTPUT_MODE_AUTO, "AUTO" },
    { RSHMC804X_VAL_OUTPUT_MODE_SINK, "SINK" },
    { RSHMC804X_VAL_OUTPUT_MODE_SOURCE, "SOUR" }
  };
RsCoreRangeTableDiscrete RsHmc804x_rngOutputMode = { 3, RsHmc804x_rngOutputModeEntries };

static RsCoreRangeTableDiscreteEntry RsHmc804x_rngQueriedOutputModeEntries[6] =
  {
    { RSHMC804X_VAL_OUTPUT_MODE_AUTO, "AUTO" },
    { RSHMC804X_VAL_OUTPUT_MODE_SINK, "SINK" },
    { RSHMC804X_VAL_OUTPUT_MODE_SOURCE, "SOUR" },
    { RSHMC804X_VAL_OUTPUT_MODE_OFF, "OFF" },
    { RSHMC804X_VAL_OUTPUT_MODE_CV, "CV" },
    { RSHMC804X_VAL_OUTPUT_MODE_CC, "CC" }
  };
RsCoreRangeTableDiscrete RsHmc804x_rngQueriedOutputMode = { 6, RsHmc804x_rngQueriedOutputModeEntries };


/*****************************************************************************
 *- Attributes --------------------------------------------------------------*
 *****************************************************************************/

RsCoreAttribute  g_RS_ATTR_RANGE_CHECK =
  {
    RS_ATTR_RANGE_CHECK,
    "Range Check",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_QUERY_INSTRUMENT_STATUS =
  {
    RS_ATTR_QUERY_INSTRUMENT_STATUS,
    "Query Instrument Status",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_TRUE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SIMULATE =
  {
    RS_ATTR_SIMULATE,
    "Simulate",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION =
  {
    RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
    "Driver Description",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_PREFIX =
  {
    RS_ATTR_SPECIFIC_DRIVER_PREFIX,
    "Driver Prefix",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR =
  {
    RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
    "Driver Locator",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_VENDOR =
  {
    RS_ATTR_SPECIFIC_DRIVER_VENDOR,
    "Driver Vendor",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_REVISION =
  {
    RS_ATTR_SPECIFIC_DRIVER_REVISION,
    "Driver Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
    "Class Specification Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
    "Class Specification Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS =
  {
    RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
    "Supported Instrument Models",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_GROUP_CAPABILITIES =
  {
    RS_ATTR_GROUP_CAPABILITIES,
    "Class Group Capabilities",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_FUNCTION_CAPABILITIES =
  {
    RS_ATTR_FUNCTION_CAPABILITIES,
    "Function Capabilities",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CHANNEL_COUNT =
  {
    RS_ATTR_CHANNEL_COUNT,
    "Channel Count",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_DRIVER_SETUP =
  {
    RS_ATTR_DRIVER_SETUP,
    "Driver Setup",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_MANUFACTURER =
  {
    RS_ATTR_INSTRUMENT_MANUFACTURER,
    "Instrument Manufacturer",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "Rohde&Schwarz",
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_MODEL =
  {
    RS_ATTR_INSTRUMENT_MODEL,
    "Instrument Model",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION =
  {
    RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
    "Instrument Firmware Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_OPTIONS_LIST =
  {
    RS_ATTR_OPTIONS_LIST,
    "Options List",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_IO_RESOURCE_DESCRIPTOR =
  {
    RS_ATTR_IO_RESOURCE_DESCRIPTOR,
    "Resource Descriptor",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_LOGICAL_NAME =
  {
    RS_ATTR_LOGICAL_NAME,
    "Logical Name",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_PRIMARY_ERROR =
  {
    RS_ATTR_PRIMARY_ERROR,
    "Primary Error",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SECONDARY_ERROR =
  {
    RS_ATTR_SECONDARY_ERROR,
    "Secondary Error",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ERROR_ELABORATION =
  {
    RS_ATTR_ERROR_ELABORATION,
    "Error Elaboration",
    RS_VAL_READ_WRITE,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
    "Driver Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
    "Driver Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION =
  {
    RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
    "Driver Minor Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION =
  {
    RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
    "Class Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION =
  {
    RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
    "Class Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_MAJOR_VERSION =
  {
    RS_ATTR_ENGINE_MAJOR_VERSION,
    "Engine Major Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_MINOR_VERSION =
  {
    RS_ATTR_ENGINE_MINOR_VERSION,
    "Engine Minor Version",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_ENGINE_REVISION =
  {
    RS_ATTR_ENGINE_REVISION,
    "Engine Revision",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "0",
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RS_ATTR_OPC_TIMEOUT =
  {
    RS_ATTR_OPC_TIMEOUT,
    "Operation Complete (OPC) Timeout",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    NULL, // No command
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_DISPLAY_CLEAR =
  {
    RSHMC804X_ATTR_DISPLAY_CLEAR,
    "Clear",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "DISP:TEXT:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_DISPLAY_TEXT =
  {
    RSHMC804X_ATTR_DISPLAY_TEXT,
    "Text",
    RS_VAL_WRITE_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "DISP:TEXT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_SELECTED_CHANNEL =
  {
    RSHMC804X_ATTR_OUTPUTS_SELECTED_CHANNEL,
    "Selected Channel",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &rshmc804x_rngChannelCount, NULL,
    "INST:NSEL",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    rshmc804x_SelectChannel_WriteCallback,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_CURRENT_LIMIT =
  {
    RSHMC804X_ATTR_OUTPUTS_CURRENT_LIMIT,
    "Current Limit",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CURR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_CURRENT_STEP_SIZE =
  {
    RSHMC804X_ATTR_OUTPUTS_CURRENT_STEP_SIZE,
    "Current Step Size",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "CURR:STEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.1,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_RESET_CURRENT_STEP_SIZE =
  {
    RSHMC804X_ATTR_OUTPUTS_RESET_CURRENT_STEP_SIZE,
    "Reset Current Step Size",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "CURR:STEP DEF",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_ENABLED,
    "Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "OUTP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    rshmc804x_OutputEnabled_WriteCallback,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MASTER_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_MASTER_ENABLED,
    "Master Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "OUTP:MAST",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    rshmc804x_MasterEnabled_ReadCallback,
    rshmc804x_MasterEnabled_WriteCallback,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_CHANNEL_ONLY_ENABLED =
  {
    RSHMC804X_ATTR_CHANNEL_ONLY_ENABLED,
    "Channel Only Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "OUTP:CHAN",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    rshmc804x_ChannelOnlyEnabled_ReadCallback,
    rshmc804x_ChannelOnlyEnabled_WriteCallback,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_VOLTAGE_LEVEL =
  {
    RSHMC804X_ATTR_OUTPUTS_VOLTAGE_LEVEL,
    "Voltage Level",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "VOLT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_VOLTAGE_STEP_SIZE =
  {
    RSHMC804X_ATTR_OUTPUTS_VOLTAGE_STEP_SIZE,
    "Voltage Step Size",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "VOLT:STEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.1,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_RESET_VOLTAGE_STEP_SIZE =
  {
    RSHMC804X_ATTR_OUTPUTS_RESET_VOLTAGE_STEP_SIZE,
    "Reset Voltage Step Size",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "VOLT:STEP DEF",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_CHANNEL_FUSION =
  {
    RSHMC804X_ATTR_CHANNEL_FUSION,
    "Channel Fusion",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &RsHmc804x_rngChannelFusion, NULL, NULL,
    "OUTP:FUS",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_CHANNEL_FUSION_OFF,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGA102|NGA142",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_MODE =
  {
    RSHMC804X_ATTR_MODE,
    "Mode",
    RS_VAL_WRITE_ONLY,
    RS_VAL_INT32,
    &RsHmc804x_rngOutputMode, NULL, NULL,
    "OUTP:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_OUTPUT_MODE_AUTO,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGF201",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_QUERY_MODE =
  {
    RSHMC804X_ATTR_QUERY_MODE,
    "Query Mode",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    &RsHmc804x_rngQueriedOutputMode, NULL, NULL,
    "OUTP:MODE?",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_OUTPUT_MODE_OFF,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGA101|NGA141|NGA102|NGA142|NGF201",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_VOLTMETER_ENABLED =
  {
    RSHMC804X_ATTR_VOLTMETER_ENABLED,
    "Voltmeter Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    ":VOLT:DVM",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGF201",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_QUERY_VOLTMETER_VALUE =
  {
    RSHMC804X_ATTR_QUERY_VOLTMETER_VALUE,
    "Query Voltmeter Value",
    RS_VAL_READ_ONLY,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "MEAS:DVM?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGF201",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENABLED,
    "Arbitrary Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "ARB",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_REPETITIONS =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_REPETITIONS,
    "Repetitions",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &rshmc804x_rngArbitraryRepetitions, NULL,
    "ARB:REP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENDPOINT =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENDPOINT,
    "Endpoint",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, &rshmc804x_rngArbitraryEndpoint, NULL,
    "ARB:ENDP",
    // Defaults I32, I64, Float, Bool, String
    512,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_RESET =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_RESET,
    "Arbitrary Reset",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "ARB:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_SAVE_FILE =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_SAVE_FILE,
    "Save File",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "ARB:SAVE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_LOAD_FILE =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_LOAD_FILE,
    "Load File",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "ARB:LOAD",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGERED =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGERED,
    "Arbitrary Triggered",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "ARB:TRIG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGER_MODE =
  {
    RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGER_MODE,
    "Trigger Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngTriggerMode, NULL, NULL,
    "ARB:TRIG:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_TRIGGER_MODE_SINGLE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_FUSE_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_FUSE_ENABLED,
    "Fuse Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "FUSE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_FUSE_DELAY =
  {
    RSHMC804X_ATTR_OUTPUTS_FUSE_DELAY,
    "Fuse Delay",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc804x_rngFuseDelay, NULL,
    "FUSE:DEL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_FUSE_LINK =
  {
    RSHMC804X_ATTR_OUTPUTS_FUSE_LINK,
    "Link",
    RS_VAL_WRITE_ONLY,
    RS_VAL_INT32,
    NULL, &rshmc804x_rngFuseLink, NULL,
    "FUSE:LINK",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_FUSE_UNLINK =
  {
    RSHMC804X_ATTR_OUTPUTS_FUSE_UNLINK,
    "Unlink",
    RS_VAL_WRITE_ONLY,
    RS_VAL_INT32,
    NULL, &rshmc804x_rngFuseLink, NULL,
    "FUSE:UNL",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_FUSE_TRIPPED =
  {
    RSHMC804X_ATTR_OUTPUTS_FUSE_TRIPPED,
    "Fuse Tripped",
    RS_VAL_READ_ONLY,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "FUSE:TRIP?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_RESET_OUTPUT_PROTECTION =
  {
    RSHMC804X_ATTR_OUTPUTS_RESET_OUTPUT_PROTECTION,
    "Reset Output Protection",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "VOLT:PROT:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OVP_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_OVP_ENABLED,
    "OVP Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:PROT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OVP_LIMIT =
  {
    RSHMC804X_ATTR_OUTPUTS_OVP_LIMIT,
    "OVP Limit",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "VOLT:PROT:LEV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OVP_TRIPPED =
  {
    RSHMC804X_ATTR_OUTPUTS_OVP_TRIPPED,
    "OVP Tripped",
    RS_VAL_READ_ONLY,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:PROT:TRIP?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OVP_MODE =
  {
    RSHMC804X_ATTR_OUTPUTS_OVP_MODE,
    "OVP Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngOvpMode, NULL, NULL,
    "VOLT:PROT:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_OVP_MODE_MEASURED,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_RESET_POWER_PROTECTION =
  {
    RSHMC804X_ATTR_OUTPUTS_RESET_POWER_PROTECTION,
    "Reset Power Protection",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "POW:PROT:CLE",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OPP_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_OPP_ENABLED,
    "OPP Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "POW:PROT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OPP_LIMIT =
  {
    RSHMC804X_ATTR_OUTPUTS_OPP_LIMIT,
    "OPP Limit",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "POW:PROT:LEV",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_OPP_TRIPPED =
  {
    RSHMC804X_ATTR_OUTPUTS_OPP_TRIPPED,
    "OPP Tripped",
    RS_VAL_READ_ONLY,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "POW:PROT:TRIP?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_RAMP_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_RAMP_ENABLED,
    "Ramp Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:RAMP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_RAMP_DURATION =
  {
    RSHMC804X_ATTR_OUTPUTS_RAMP_DURATION,
    "Duration",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, &rshmc804x_rngRampDuration, NULL,
    "VOLT:RAMP:DUR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_AINPUT_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_AINPUT_ENABLED,
    "Analog Input Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "VOLT:AINP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_AINPUT_INPUT =
  {
    RSHMC804X_ATTR_OUTPUTS_AINPUT_INPUT,
    "Input",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngAnalogInput, NULL, NULL,
    "VOLT:AINP:INP",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_AINPUT_VOLTAGE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_AINPUT_MODE =
  {
    RSHMC804X_ATTR_OUTPUTS_AINPUT_MODE,
    "Analog Input Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngAnalogInputMode, NULL, NULL,
    "VOLT:AINP:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_AINPUT_MODE_LINEAR,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_AINPUT_THRESHOLD =
  {
    RSHMC804X_ATTR_OUTPUTS_AINPUT_THRESHOLD,
    "Threshold",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "VOLT:AINP:THR",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.1,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_ENABLED,
    "Log Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "LOG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_CHANNEL_LOG_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_CHANNEL_LOG_ENABLED,
    "Channel Logging Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "LOG:CHAN",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_FORMAT =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_FORMAT,
    "Format",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngLoggingFormat, NULL, NULL,
    "LOG:FORM",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_LOGGING_FORMAT_CSV,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_MODE =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_MODE,
    "Log Mode",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngLoggingMode, NULL, NULL,
    "LOG:MODE",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_LOGGING_MODE_UNLIMITED,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TIME =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TIME,
    "Time",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "LOG:TIME",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    1.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_COUNT =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_COUNT,
    "Count",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "LOG:COUN",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_INTERVAL =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_INTERVAL,
    "Interval",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "LOG:INT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TRIGGERED =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TRIGGERED,
    "Log Triggered",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "LOG:TRIG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_ENABLED,
    "Energy Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "MEAS:ENER:STAT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_RESET =
  {
    RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_RESET,
    "Energy Reset",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "MEAS:ENER:RES",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_SEQUENCE_ENABLED,
    "Sequence Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SEQ",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY_ENABLED =
  {
    RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY_ENABLED,
    "Delay Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SEQ:CHAN",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY =
  {
    RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY,
    "Sequence Delay",
    RS_VAL_READ_WRITE,
    RS_VAL_REAL64,
    NULL, NULL, NULL,
    "SEQ:DEL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_TRIGGERED =
  {
    RSHMC804X_ATTR_OUTPUTS_SEQUENCE_TRIGGERED,
    "Sequence Triggered",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SEQ:TRIG",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_TRIGGER_SLOPE =
  {
    RSHMC804X_ATTR_TRIGGER_SLOPE,
    "Slope",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngTriggerSlope, NULL, NULL,
    "TRIG:SLOP",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_TRIGGER_SLOPE_NEGATIVE,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_HCOPY_IMAGE_FORMAT =
  {
    RSHMC804X_ATTR_HCOPY_IMAGE_FORMAT,
    "Image Format",
    RS_VAL_READ_WRITE,
    RS_VAL_INT32,
    &rshmc804x_rngImageFormat, NULL, NULL,
    "HCOP:FORM",
    // Defaults I32, I64, Float, Bool, String
    RSHMC804X_VAL_IMAGE_FORMAT_BMP,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_HCOPY_IMAGE_WIDTH =
  {
    RSHMC804X_ATTR_HCOPY_IMAGE_WIDTH,
    "Image Width",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "HCOP:SIZE:X?",
    // Defaults I32, I64, Float, Bool, String
    1920,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_HCOPY_IMAGE_HEIGHT =
  {
    RSHMC804X_ATTR_HCOPY_IMAGE_HEIGHT,
    "Image Height",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "HCOP:SIZE:Y?",
    // Defaults I32, I64, Float, Bool, String
    1080,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_BEEPER_ENABLED =
  {
    RSHMC804X_ATTR_SYSTEM_BEEPER_ENABLED,
    "Beeper Enabled",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "SYST:BEEP:STAT",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_BEEP_START =
  {
    RSHMC804X_ATTR_SYSTEM_BEEP_START,
    "Start Beep",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:BEEP",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_ERROR =
  {
    RSHMC804X_ATTR_SYSTEM_ERROR,
    "System Error",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:ERR?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_LOCAL =
  {
    RSHMC804X_ATTR_SYSTEM_LOCAL,
    "System Local",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:LOC",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_REMOTE =
  {
    RSHMC804X_ATTR_SYSTEM_REMOTE,
    "System Remote",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:REM",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_RWLOCK =
  {
    RSHMC804X_ATTR_SYSTEM_RWLOCK,
    "System RWLock",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "SYST:RWL",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_VERSION =
  {
    RSHMC804X_ATTR_SYSTEM_VERSION,
    "System Version",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:VERS?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_OPTIONS =
  {
    RSHMC804X_ATTR_SYSTEM_OPTIONS,
    "System Options",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:OPT?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "K0",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGA101|NGA141|NGA102|NGA142",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SYSTEM_DEVICE_FOOT_PRINT =
  {
    RSHMC804X_ATTR_SYSTEM_DEVICE_FOOT_PRINT,
    "System Device Foot Print",
    RS_VAL_READ_ONLY,
    RS_VAL_STRING,
    NULL, NULL, NULL,
    "SYST:DFPR?",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    "info",
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    "NGA101|NGA141|NGA102|NGA142",
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_STATUS_PRESET =
  {
    RSHMC804X_ATTR_STATUS_PRESET,
    "Status Preset",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "STAT:PRES",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_LOGGING =
  {
    RSHMC804X_ATTR_LOGGING,
    "Logging",
    RS_VAL_READ_WRITE,
    RS_VAL_BOOLEAN,
    NULL, NULL, NULL,
    "no_command",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    rshmc804x_logging_ReadCallback,
    rshmc804x_logging_WriteCallback,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_SELF_TEST_QUERY =
  {
    RSHMC804X_ATTR_SELF_TEST_QUERY,
    "Self-Test Query",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "*TST?",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_WAIT_FOR_OPC,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_QUERY_OPC =
  {
    RSHMC804X_ATTR_QUERY_OPC,
    "Query OPC",
    RS_VAL_READ_ONLY,
    RS_VAL_INT32,
    NULL, NULL, NULL,
    "*OPC?",
    // Defaults I32, I64, Float, Bool, String
    1,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    0,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };

RsCoreAttribute  g_RSHMC804X_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS =
  {
    RSHMC804X_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS,
    "Process All Previous Commands",
    RS_VAL_WRITE_ONLY,
    RS_VAL_EVENT,
    NULL, NULL, NULL,
    "*WAI",
    // Defaults I32, I64, Float, Bool, String
    0,
    0,
    0.0,
    VI_FALSE,
    NULL,
    // Flags, HasRepCaps
    RS_VAL_DONT_CHECK_STATUS,
    VI_FALSE,
    // Models, Options
    NULL,
    NULL,
    // Callbacks Read, Write, p2Value
    NULL,
    NULL,
    NULL,
  };


/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/

ViInt32 rshmc804x_RsCoreAttributeListLength = 110;

RsCoreAttributePtr rshmc804x_RsCoreAttributeList[110] =
  {
    &g_RS_ATTR_RANGE_CHECK,
    &g_RS_ATTR_QUERY_INSTRUMENT_STATUS,
    &g_RS_ATTR_SIMULATE,
    &g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION,
    &g_RS_ATTR_SPECIFIC_DRIVER_PREFIX,
    &g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR,
    &g_RS_ATTR_SPECIFIC_DRIVER_VENDOR,
    &g_RS_ATTR_SPECIFIC_DRIVER_REVISION,
    &g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION,
    &g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS,
    &g_RS_ATTR_GROUP_CAPABILITIES,
    &g_RS_ATTR_FUNCTION_CAPABILITIES,
    &g_RS_ATTR_CHANNEL_COUNT,
    &g_RS_ATTR_DRIVER_SETUP,
    &g_RS_ATTR_INSTRUMENT_MANUFACTURER,
    &g_RS_ATTR_INSTRUMENT_MODEL,
    &g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION,
    &g_RS_ATTR_OPTIONS_LIST,
    &g_RS_ATTR_IO_RESOURCE_DESCRIPTOR,
    &g_RS_ATTR_LOGICAL_NAME,
    &g_RS_ATTR_PRIMARY_ERROR,
    &g_RS_ATTR_SECONDARY_ERROR,
    &g_RS_ATTR_ERROR_ELABORATION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION,
    &g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION,
    &g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION,
    &g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION,
    &g_RS_ATTR_ENGINE_MAJOR_VERSION,
    &g_RS_ATTR_ENGINE_MINOR_VERSION,
    &g_RS_ATTR_ENGINE_REVISION,
    &g_RS_ATTR_OPC_TIMEOUT,
    &g_RSHMC804X_ATTR_DISPLAY_CLEAR,
    &g_RSHMC804X_ATTR_DISPLAY_TEXT,
    &g_RSHMC804X_ATTR_OUTPUTS_SELECTED_CHANNEL,
    &g_RSHMC804X_ATTR_OUTPUTS_CURRENT_LIMIT,
    &g_RSHMC804X_ATTR_OUTPUTS_CURRENT_STEP_SIZE,
    &g_RSHMC804X_ATTR_OUTPUTS_RESET_CURRENT_STEP_SIZE,
    &g_RSHMC804X_ATTR_OUTPUTS_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_MASTER_ENABLED,
    &g_RSHMC804X_ATTR_CHANNEL_ONLY_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_VOLTAGE_LEVEL,
    &g_RSHMC804X_ATTR_OUTPUTS_VOLTAGE_STEP_SIZE,
    &g_RSHMC804X_ATTR_OUTPUTS_RESET_VOLTAGE_STEP_SIZE,
    &g_RSHMC804X_ATTR_CHANNEL_FUSION,
    &g_RSHMC804X_ATTR_MODE,
    &g_RSHMC804X_ATTR_QUERY_MODE,
    &g_RSHMC804X_ATTR_VOLTMETER_ENABLED,
    &g_RSHMC804X_ATTR_QUERY_VOLTMETER_VALUE,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_REPETITIONS,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENDPOINT,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_RESET,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_SAVE_FILE,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_LOAD_FILE,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGERED,
    &g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGER_MODE,
    &g_RSHMC804X_ATTR_OUTPUTS_FUSE_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_FUSE_DELAY,
    &g_RSHMC804X_ATTR_OUTPUTS_FUSE_LINK,
    &g_RSHMC804X_ATTR_OUTPUTS_FUSE_UNLINK,
    &g_RSHMC804X_ATTR_OUTPUTS_FUSE_TRIPPED,
    &g_RSHMC804X_ATTR_OUTPUTS_RESET_OUTPUT_PROTECTION,
    &g_RSHMC804X_ATTR_OUTPUTS_OVP_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_OVP_LIMIT,
    &g_RSHMC804X_ATTR_OUTPUTS_OVP_TRIPPED,
    &g_RSHMC804X_ATTR_OUTPUTS_OVP_MODE,
    &g_RSHMC804X_ATTR_OUTPUTS_RESET_POWER_PROTECTION,
    &g_RSHMC804X_ATTR_OUTPUTS_OPP_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_OPP_LIMIT,
    &g_RSHMC804X_ATTR_OUTPUTS_OPP_TRIPPED,
    &g_RSHMC804X_ATTR_OUTPUTS_RAMP_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_RAMP_DURATION,
    &g_RSHMC804X_ATTR_OUTPUTS_AINPUT_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_AINPUT_INPUT,
    &g_RSHMC804X_ATTR_OUTPUTS_AINPUT_MODE,
    &g_RSHMC804X_ATTR_OUTPUTS_AINPUT_THRESHOLD,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_CHANNEL_LOG_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_FORMAT,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_MODE,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TIME,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_COUNT,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_INTERVAL,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TRIGGERED,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_RESET,
    &g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY_ENABLED,
    &g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY,
    &g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_TRIGGERED,
    &g_RSHMC804X_ATTR_TRIGGER_SLOPE,
    &g_RSHMC804X_ATTR_HCOPY_IMAGE_FORMAT,
    &g_RSHMC804X_ATTR_HCOPY_IMAGE_WIDTH,
    &g_RSHMC804X_ATTR_HCOPY_IMAGE_HEIGHT,
    &g_RSHMC804X_ATTR_SYSTEM_BEEPER_ENABLED,
    &g_RSHMC804X_ATTR_SYSTEM_BEEP_START,
    &g_RSHMC804X_ATTR_SYSTEM_ERROR,
    &g_RSHMC804X_ATTR_SYSTEM_LOCAL,
    &g_RSHMC804X_ATTR_SYSTEM_REMOTE,
    &g_RSHMC804X_ATTR_SYSTEM_RWLOCK,
    &g_RSHMC804X_ATTR_SYSTEM_VERSION,
    &g_RSHMC804X_ATTR_SYSTEM_OPTIONS,
    &g_RSHMC804X_ATTR_SYSTEM_DEVICE_FOOT_PRINT,
    &g_RSHMC804X_ATTR_STATUS_PRESET,
    &g_RSHMC804X_ATTR_LOGGING,
    &g_RSHMC804X_ATTR_SELF_TEST_QUERY,
    &g_RSHMC804X_ATTR_QUERY_OPC,
    &g_RSHMC804X_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS
  };
