/*****************************************************************************
 *  Rohde&Schwarz Instrument Driver Specific Attribute callbacks include file
 *
 *  WARNING: Do not add to, delete from, or otherwise modify the contents
 *           of this include file. It is generated from DrBase repository.
 *
 *  Built on: 2023-07-25 15:02:31Z
 *****************************************************************************/

#ifndef __RSHMC804X_ATTRIBUTES_HEADER
#define __RSHMC804X_ATTRIBUTES_HEADER

#include "rscore.h"

#if defined(__cplusplus) || defined(__cplusplus__)
extern "C" {
#endif

/*****************************************************************************
 *- Read Callbacks ----------------------------------------------------------*
 *****************************************************************************/
ViStatus rshmc804x_MasterEnabled_ReadCallback(ViSession          io,
                                              ViConstString      repCapName,
                                              RsCoreAttributePtr attr);

ViStatus rshmc804x_ChannelOnlyEnabled_ReadCallback(ViSession          io,
                                                   ViConstString      repCapName,
                                                   RsCoreAttributePtr attr);

ViStatus rshmc804x_logging_ReadCallback(ViSession          io,
                                        ViConstString      repCapName,
                                        RsCoreAttributePtr attr);

/*****************************************************************************
 *- Write Callbacks ---------------------------------------------------------*
 *****************************************************************************/
ViStatus rshmc804x_SelectChannel_WriteCallback(ViSession          io,
                                               ViConstString      repCapName,
                                               RsCoreAttributePtr attr,
                                               void               *value);

ViStatus rshmc804x_OutputEnabled_WriteCallback(ViSession          io,
                                               ViConstString      repCapName,
                                               RsCoreAttributePtr attr,
                                               void               *value);

ViStatus rshmc804x_MasterEnabled_WriteCallback(ViSession          io,
                                               ViConstString      repCapName,
                                               RsCoreAttributePtr attr,
                                               void               *value);

ViStatus rshmc804x_ChannelOnlyEnabled_WriteCallback(ViSession          io,
                                                    ViConstString      repCapName,
                                                    RsCoreAttributePtr attr,
                                                    void               *value);

ViStatus rshmc804x_logging_WriteCallback(ViSession          io,
                                         ViConstString      repCapName,
                                         RsCoreAttributePtr attr,
                                         void               *value);

/*****************************************************************************
 *- Range Tables ------------------------------------------------------------*
 *****************************************************************************/
extern RsCoreRangeTableDiscrete rshmc804x_rngMeasurementType;
extern RsCoreRangeTableDiscrete rshmc804x_rngTriggerSlope;
extern RsCoreRangeTableRanged rshmc804x_rngChannelCount;
extern RsCoreRangeTableDiscrete rshmc804x_rngOvpMode;
extern RsCoreRangeTableRanged rshmc804x_rngRampDuration;
extern RsCoreRangeTableDiscrete rshmc804x_rngAnalogInput;
extern RsCoreRangeTableDiscrete rshmc804x_rngAnalogInputMode;
extern RsCoreRangeTableRanged rshmc804x_rngFuseDelay;
extern RsCoreRangeTableRanged rshmc804x_rngFuseLink;
extern RsCoreRangeTableRanged rshmc804x_rngArbitraryRepetitions;
extern RsCoreRangeTableRanged rshmc804x_rngArbitraryEndpoint;
extern RsCoreRangeTableDiscrete rshmc804x_rngLoggingFormat;
extern RsCoreRangeTableDiscrete rshmc804x_rngLoggingMode;
extern RsCoreRangeTableDiscrete rshmc804x_rngDevice;
extern RsCoreRangeTableDiscrete rshmc804x_rngRegisterGroup;
extern RsCoreRangeTableDiscrete rshmc804x_rngRegisterType;
extern RsCoreRangeTableDiscrete rshmc804x_rngImageFormat;
extern RsCoreRangeTableDiscrete rshmc804x_rngTriggerMode;
extern RsCoreRangeTableDiscrete RsHmc804x_rngChannelFusion;
extern RsCoreRangeTableDiscrete RsHmc804x_rngOutputMode;
extern RsCoreRangeTableDiscrete RsHmc804x_rngQueriedOutputMode;

/*****************************************************************************
 *- Attributes --------------------------------------------------------------*
 *****************************************************************************/
extern RsCoreAttribute g_RS_ATTR_RANGE_CHECK;
extern RsCoreAttribute g_RS_ATTR_QUERY_INSTRUMENT_STATUS;
extern RsCoreAttribute g_RS_ATTR_SIMULATE;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_DESCRIPTION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_PREFIX;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_LOCATOR;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_VENDOR;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_REVISION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_CLASS_SPEC_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SUPPORTED_INSTRUMENT_MODELS;
extern RsCoreAttribute g_RS_ATTR_GROUP_CAPABILITIES;
extern RsCoreAttribute g_RS_ATTR_FUNCTION_CAPABILITIES;
extern RsCoreAttribute g_RS_ATTR_CHANNEL_COUNT;
extern RsCoreAttribute g_RS_ATTR_DRIVER_SETUP;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_MANUFACTURER;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_MODEL;
extern RsCoreAttribute g_RS_ATTR_INSTRUMENT_FIRMWARE_REVISION;
extern RsCoreAttribute g_RS_ATTR_OPTIONS_LIST;
extern RsCoreAttribute g_RS_ATTR_IO_RESOURCE_DESCRIPTOR;
extern RsCoreAttribute g_RS_ATTR_LOGICAL_NAME;
extern RsCoreAttribute g_RS_ATTR_PRIMARY_ERROR;
extern RsCoreAttribute g_RS_ATTR_SECONDARY_ERROR;
extern RsCoreAttribute g_RS_ATTR_ERROR_ELABORATION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_SPECIFIC_DRIVER_MINOR_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_CLASS_DRIVER_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_CLASS_DRIVER_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_MAJOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_MINOR_VERSION;
extern RsCoreAttribute g_RS_ATTR_ENGINE_REVISION;
extern RsCoreAttribute g_RS_ATTR_OPC_TIMEOUT;
extern RsCoreAttribute g_RSHMC804X_ATTR_DISPLAY_CLEAR;
extern RsCoreAttribute g_RSHMC804X_ATTR_DISPLAY_TEXT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_SELECTED_CHANNEL;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_CURRENT_LIMIT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_CURRENT_STEP_SIZE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_RESET_CURRENT_STEP_SIZE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MASTER_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_CHANNEL_ONLY_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_VOLTAGE_LEVEL;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_VOLTAGE_STEP_SIZE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_RESET_VOLTAGE_STEP_SIZE;
extern RsCoreAttribute g_RSHMC804X_ATTR_CHANNEL_FUSION;
extern RsCoreAttribute g_RSHMC804X_ATTR_MODE;
extern RsCoreAttribute g_RSHMC804X_ATTR_QUERY_MODE;
extern RsCoreAttribute g_RSHMC804X_ATTR_VOLTMETER_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_QUERY_VOLTMETER_VALUE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_REPETITIONS;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_ENDPOINT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_RESET;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_SAVE_FILE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_LOAD_FILE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGERED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_ARBITRARY_TRIGGER_MODE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_FUSE_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_FUSE_DELAY;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_FUSE_LINK;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_FUSE_UNLINK;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_FUSE_TRIPPED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_RESET_OUTPUT_PROTECTION;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OVP_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OVP_LIMIT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OVP_TRIPPED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OVP_MODE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_RESET_POWER_PROTECTION;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OPP_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OPP_LIMIT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_OPP_TRIPPED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_RAMP_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_RAMP_DURATION;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_AINPUT_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_AINPUT_INPUT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_AINPUT_MODE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_AINPUT_THRESHOLD;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_CHANNEL_LOG_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_FORMAT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_MODE;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TIME;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_COUNT;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_INTERVAL;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_LOG_TRIGGERED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_MEAS_ENERGY_RESET;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_DELAY;
extern RsCoreAttribute g_RSHMC804X_ATTR_OUTPUTS_SEQUENCE_TRIGGERED;
extern RsCoreAttribute g_RSHMC804X_ATTR_TRIGGER_SLOPE;
extern RsCoreAttribute g_RSHMC804X_ATTR_HCOPY_IMAGE_FORMAT;
extern RsCoreAttribute g_RSHMC804X_ATTR_HCOPY_IMAGE_WIDTH;
extern RsCoreAttribute g_RSHMC804X_ATTR_HCOPY_IMAGE_HEIGHT;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_BEEPER_ENABLED;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_BEEP_START;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_ERROR;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_LOCAL;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_REMOTE;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_RWLOCK;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_VERSION;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_OPTIONS;
extern RsCoreAttribute g_RSHMC804X_ATTR_SYSTEM_DEVICE_FOOT_PRINT;
extern RsCoreAttribute g_RSHMC804X_ATTR_STATUS_PRESET;
extern RsCoreAttribute g_RSHMC804X_ATTR_LOGGING;
extern RsCoreAttribute g_RSHMC804X_ATTR_SELF_TEST_QUERY;
extern RsCoreAttribute g_RSHMC804X_ATTR_QUERY_OPC;
extern RsCoreAttribute g_RSHMC804X_ATTR_PROCESS_ALL_PREVIOUS_COMMANDS;

/*****************************************************************************
 *- Repeated Capabilities Table ---------------------------------------------*
 *****************************************************************************/
extern RsCoreRepCap rshmc804x_RsCoreRepCapTable[];
extern ViInt32 rshmc804x_RsCoreRepCapTableCount;

/*****************************************************************************
 *- Attributes List ---------------------------------------------------------*
 *****************************************************************************/
extern RsCoreAttributePtr rshmc804x_RsCoreAttributeList[];
extern ViInt32 rshmc804x_RsCoreAttributeListLength;

/****************************************************************************
 *---------------------------- End Include File ----------------------------*
 ****************************************************************************/
#if defined(__cplusplus) || defined(__cplusplus__)
}
#endif
#endif /* __RSHMC804X_ATTRIBUTES_HEADER */
